; Compiled with: PIC Simulator IDE v6.73
; Microcontroller model: PIC16F88
; Clock frequency: 10.0 MHz
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	SCL_PORT EQU 0x2C
	SCL_BIT EQU 0x2D
	SDA_PORT EQU 0x2E
	SDA_BIT EQU 0x2F
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0019
	ORG 0x0004
	RETFIE
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x30
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x04
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x04
	SUBWF R4L,F
	NOP
	NOP
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x07
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x04
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x14
	MOVWF R4L
	CALL X001
	BSF ADCON0,GO
A002:	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN
; ShiftLeft Routine
SL01:	BCF STATUS,C
	RLF R0L,F
	RLF R0H,F
SL00:	ADDLW 0xFF
	BTFSC STATUS,C
	GOTO SL01
	MOVF R0L,W
	RETURN
; ShiftRight Routine
SR01:	BCF STATUS,C
	RRF R0H,F
	RRF R0L,F
SR00:	ADDLW 0xFF
	BTFSC STATUS,C
	GOTO SR01
	MOVF R0L,W
	RETURN
; Hardware Serial Communication Routines
HS01:	BTFSC PIR1,TXIF
	GOTO HS02
	GOTO HS01
HS02:	MOVWF TXREG
	RETURN
HS10:	BTFSC PIR1,RCIF
	GOTO HS11
	GOTO HS10
HS11:	MOVF RCREG,W
	RETURN
; I2CWrite Routine
IC01:	MOVWF R0L
	MOVLW 0x08
	MOVWF R0H
IC02:	RLF R0L,F
	BTFSC STATUS,C
	CALL IC20
	BTFSS STATUS,C
	CALL IC21
	CALL IC22
	CALL IC23
	DECFSZ R0H,F
	GOTO IC02
	CALL IC24
	CALL IC03
	CALL IC25
	CALL IC21
	RETURN
IC03:	CALL IC22
	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	ANDWF INDF,W
	ADDLW 0xFF
	CALL IC23
	RETURN
IC31:	CALL IC21
	CALL IC23
	GOTO IC29
IC41:	CALL IC22
	CALL IC20
	GOTO IC29
IC20:	MOVF SDA_PORT,W
	MOVWF FSR
	MOVF SDA_BIT,W
	IORWF INDF,F
	GOTO IC28
IC21:	MOVF SDA_PORT,W
	MOVWF FSR
	COMF SDA_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC22:	MOVF SCL_PORT,W
	MOVWF FSR
	MOVF SCL_BIT,W
	IORWF INDF,F
	GOTO IC28
IC23:	MOVF SCL_PORT,W
	MOVWF FSR
	COMF SCL_BIT,W
	ANDWF INDF,F
	GOTO IC28
IC28:	BSF FSR,7
	COMF INDF,W
	BCF FSR,7
	ANDWF INDF,F
IC29:	NOP
	NOP
	NOP
	RETURN
IC24:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	MOVF SDA_BIT,W
	IORWF INDF,F
	RETURN
IC25:	MOVF SDA_PORT,W
	MOVWF FSR
	BSF FSR,7
	COMF SDA_BIT,W
	ANDWF INDF,F
	RETURN
; I2CRead Routine
IC11:	CALL IC15
	MOVLW 0x08
	MOVWF R0H
IC12:	CALL IC03
	RLF R0L,F
	DECFSZ R0H,F
	GOTO IC12
	CALL IC25
	CALL IC20
	CALL IC22
	CALL IC23
	CALL IC21
	MOVF R0L,W
	RETURN
IC13:	CALL IC15
	MOVLW 0x08
	MOVWF R0H
IC14:	CALL IC03
	RLF R0L,F
	DECFSZ R0H,F
	GOTO IC14
	CALL IC25
	CALL IC21
	CALL IC22
	CALL IC23
	MOVF R0L,W
	RETURN
IC15:	CALL IC24
	MOVLW 0x50
	MOVWF R4L
	MOVLW 0x00
	MOVWF R4H
	CALL Y001
	RETURN
; Begin of program
L0019:
; 1: Define CONF_WORD = 0x3f63 'external clock
; 2: Define CONF_WORD_2 = 0x3ffc
; 3: 
; 4:  'Define CONF_WORD = 0x3f62 ' HS clock Osc
; 5: 
; 6:  'Rs232 to I2C and others controler Paul McMahon VK3DIP 10/01/2009
; 7:  'set up for a 16f88
; 8: 
; 9:  'Commands from PC
; 10: 
; 11:  'W aa,hh,hh,hh,hh,..<CR><LF>
; 12:  'Write to I2C device (ie Tuner)at slave address aa
; 13:  'at least 1 up to decimal 17 bytes hh, first hh can be ss a subaddress if required
; 14:  'response to PC from write
; 15:  'OK
; 16: 
; 17:  'R aa<CR><LF>
; 18:  'Read one byte from I2C device at slave address aa
; 19:  'response to PC from Read
; 20:  'Raa=hh<CR><LF>
; 21: 
; 22:  'R aa,nn<CR><LF>
; 23:  'Read nn (01 < nn < ff )bytes from from I2C device at slave address aa
; 24:  'response to PC from Read
; 25:  'Raa=hh,hh,hh..<CR><LF>
; 26: 
; 27:  'R aa,ss,nn<CR><LF>
; 28:  'Read nn (01 < nn < ff )bytes from from I2C device
; 29:  'at slave address aa, subaddress ss, all in lowercase hex
; 30:  'response to PC from Read
; 31:  'Raass=hh,hh,hh..<CR><LF>
; 32: 
; 33:  'R aa,ssss,nn<CR><LF>
; 34:  'Read nn (01 < nn < ff )bytes from from I2C device
; 35:  'at slave address aa, subaddress ssss, all in lowercase hex
; 36:  'response to PC from Read
; 37:  'Raassss=hh,hh,hh..<CR><LF>
; 38: 
; 39: 
; 40:  'D hh,hh,hh,hh,hh<CR><LF>
; 41:  'Write to DDS device (ie AD9850)up to 40 bits commas optional
; 42:  'last typed hh is done first bit 0 sent first then bit 1  to bit 7, then next hh ie right to left
; 43:  'response to PC from write
; 44:  'OK
; 45: 
; 46:  'V 0p,nn<CR><LF>
; 47:  'Get 10 bit analog voltage from port 0p, 0p = 00,01,02 (03 = 00&01&02)
; 48:  'if nn present repeat for hex value nm times, if not present do once
; 49:  'Response to PC
; 50:  'V0p=hhhh<CR><LF>
; 51: 
; 52:  'B 0b<CR><LF>
; 53:  'Set digital bits out for RB7,RB3,RA4  0p = 00 to 07
; 54:  '00 => RB7,RB3,RA4  = 0,0,0 :  07 => RB7,RB3,RA4  = 1,1,1
; 55:  'Response to PC
; 56:  'OK
; 57: 
; 58:  'P hh <CR><LF>
; 59:  'PWM out ( on RB0) 8 bit duty cycle at approx 8 Khz
; 60:  'hh is 2 hex bytes giving 0 - 255 (00 To FF) levels
; 61:  '00 is off 01 - FF is on.
; 62:  'Response to PC
; 63:  'OK
; 64: 
; 65:  'F gt<CR><LF>
; 66:  'Get 3 byte hex count from T1CLK input for gt  01 = 0.1 second, 10 = 1 second
; 67:  'Response to PC
; 68:  'Fgt=hhhhhh<CR><LF>
; 69: 
; 70:  'C 0p,dd<CR><LF>
; 71:  'wait for sda pin to from high to low then
; 72:  'get series of 10 Bit analog voltages from port 0p, 0p = 00, 01, 02, Not 03
; 73:  'at delay 0.1 plus dd ( 00 to ff) * 0.1 ms between each sample.
; 74:  'fill buffer with analog readings hhhh and then send to PC.
; 75:  'Response to PC
; 76:  'C0p,dd<CR><LF>
; 77:  '[<CR><LF>
; 78:  'hhhh<CR><LF>
; 79:  'hhhh<CR><LF>
; 80:  'hhhh<CR><LF>
; 81:  'hhhh<CR><LF>
; 82:  '.....
; 83:  'hhhh<CR><LF>
; 84:  'hhhh<CR><LF>
; 85:  ']<CR><LF>
; 86: 
; 87: 
; 88: 
; 89:  '? <CR><LF>
; 90:  'Get Version Info
; 91:  'Response to PC
; 92:  'Version Info
; 93: 
; 94: 
; 95:  'repeat last command
; 96:  '<CR><LF>
; 97: 
; 98:  'In all cases spaces, commas etc. treated as white space and ignored
; 99:  'All hex alpha characters must be lower case, all commands are upper case.
; 100:  'aa is a ascii hex byte defining the I2C slave address
; 101:  'hh is a hex byte 00 to ff ( lower case only)
; 102:  '0p = 00,01,02 for relevant port
; 103:  '0p = 00,01,02,03,04,05,06,07 on RB7,RB3,RA4 as three least significant bits
; 104: 
; 105:  'hhhh = four digit hex number 0000 to 03ff coresponding to 0V to +Ref on A.3
; 106:  'hhhhhh = 6 digit hex number 000000 to ffffff coresponding to count for selected gate time.
; 107: 
; 108: 
; 109: Const hinib = %11110000 'masks for getting nibbles
;       The value of 'hinib' is 240
; 110: Const lonib = %00001111
;       The value of 'lonib' is 15
; 111: Symbol sda = PORTB.1 'use RB1 as SDA pin and Capture trigger
;       The address of 'sda' is 0x6,1
; 112: Symbol scl = PORTB.4 'use RB4 as SCL pin
;       The address of 'scl' is 0x6,4
; 113: Symbol gend1 = PORTA.4 'Generic digital out LSB, also DDS W_CLK
;       The address of 'gend1' is 0x5,4
; 114: Symbol gend2 = PORTB.3 'Generic digital middle bit, also DDS Data
;       The address of 'gend2' is 0x6,3
; 115: Symbol gend3 = PORTB.7 'Generic digital MSB, also DDS FQ_UD
;       The address of 'gend3' is 0x6,7
; 116: 
; 117: 
; 118: Dim sladdr As Byte 'I2C Slave address
;       The address of 'sladdr' is 0x31
	sladdr EQU 0x31
; 119: Dim dnib As Bit 'nibble we are up to 1 = hi, 0 = lo
;       The address of 'dnib' is 0x30,0
; 120: Dim mycmd As Byte 'command to be executed
;       The address of 'mycmd' is 0x32
	mycmd EQU 0x32
; 121:  '0 = none, 1 = I2C write, 2 = i2creadread, 3 = Analog read, 4 = ?,
; 122:  '5 = PWM, 6 = frequency, 7 = digital out, 8 = DDS out, 9 = Capture
; 123: Dim dcnt As Byte 'count of data bytes max should be 49, 0 = no data
;       The address of 'dcnt' is 0x33
	dcnt EQU 0x33
; 124: Dim rdata As Byte 'General read in of one byte
;       The address of 'rdata' is 0x34
	rdata EQU 0x34
; 125: Dim myhex As Byte 'common hex value
;       The address of 'myhex' is 0x35
	myhex EQU 0x35
; 126: Dim myparam As Byte
;       The address of 'myparam' is 0x36
	myparam EQU 0x36
; 127: Dim mysubval As Byte
;       The address of 'mysubval' is 0x37
	mysubval EQU 0x37
; 128: Dim myp2 As Byte
;       The address of 'myp2' is 0x38
	myp2 EQU 0x38
; 129: Dim mycnt As Byte
;       The address of 'mycnt' is 0x39
	mycnt EQU 0x39
; 130: Dim mycnt2 As Byte
;       The address of 'mycnt2' is 0x3A
	mycnt2 EQU 0x3A
; 131: Dim mychar As Byte 'char in from serial etc. port
;       The address of 'mychar' is 0x3B
	mychar EQU 0x3B
; 132: Dim myvolts As Word 'read in 10 bit voltage
;       The address of 'myvolts' is 0x3C
	myvolts EQU 0x3C
; 133: Dim myd1 As Byte
;       The address of 'myd1' is 0x3E
	myd1 EQU 0x3E
; 134: Dim myd2 As Byte
;       The address of 'myd2' is 0x3F
	myd2 EQU 0x3F
; 135: Dim myd3 As Byte
;       The address of 'myd3' is 0x40
	myd3 EQU 0x40
; 136: Dim myb2 As Byte
;       The address of 'myb2' is 0x41
	myb2 EQU 0x41
; 137: Dim myb1 As Byte
;       The address of 'myb1' is 0x42
	myb1 EQU 0x42
; 138: Dim myb0 As Byte
;       The address of 'myb0' is 0x43
	myb0 EQU 0x43
; 139: Dim mydbit As Byte 'passed DiBit first 2 bits only used
;       The address of 'mydbit' is 0x44
	mydbit EQU 0x44
; 140: Dim mybyte As Byte 'passed byte
;       The address of 'mybyte' is 0x45
	mybyte EQU 0x45
; 141: Dim tempstr As Byte 'temporary store on way in or out of main store
;       The address of 'tempstr' is 0x46
	tempstr EQU 0x46
; 142: Dim tempnxt As Byte 'location of next DiBit in tempstr ie. 0,2,4,6
;       The address of 'tempnxt' is 0x47
	tempnxt EQU 0x47
; 143: Const maxb0 = 49 'maximum index of block 0
;       The value of 'maxb0' is 49
; 144: Const maxb1 = 79 'maximum index of block 1
;       The value of 'maxb1' is 79
; 145: Const maxb2 = 95 'maximum index of block 2
;       The value of 'maxb2' is 95
; 146: Const maxb3 = 95 'maximum index of block 3
;       The value of 'maxb3' is 95
; 147: Dim mymax(4) As Byte 'maximum of block 0 - 3
;       The address of 'mymax' is 0x48
	mymax EQU 0x48
; 148: Dim bptr As Byte 'current block pointer
;       The address of 'bptr' is 0x4C
	bptr EQU 0x4C
; 149: Dim aptr As Byte 'current address in block pointer
;       The address of 'aptr' is 0x4D
	aptr EQU 0x4D
; 150: Dim mydata(50) As Byte 'data bytes to send to the tuner, plus block 0
;       The address of 'mydata' is 0x4E
	mydata EQU 0x4E
; 151: Dim mydata1(80) As Byte 'block 1
;       The address of 'mydata1' is 0xA0
	mydata1 EQU 0xA0
; 152: Dim mydata2(96) As Byte 'block 2
;       The address of 'mydata2' is 0x110
	mydata2 EQU 0x110
; 153: Dim mydata3(96) As Byte 'block 3
;       The address of 'mydata3' is 0x190
	mydata3 EQU 0x190
; 154: 
; 155: Define I2CREAD_DELAYUS = 80 '0 and 20 give 1/2 true range, 50 OK
; 156:  'Define I2CCLOCK_STRETCH = 2 - doesn't seem to be needed with phillips tuners
; 157: TRISA = %11101111 'set all PORTA pins as inputs except A4 to use as D0 out
	BSF STATUS,RP0
	MOVLW 0xEF
	MOVWF 0x05
; 158: TRISB = %01010110 'set PORTB pins
	MOVLW 0x56
	MOVWF 0x06
; 159: ANSEL = %00001111 'set analog inputs
	MOVLW 0x0F
	MOVWF 0x1B
; 160:  'ADCON0 = 0xc0  ' don't set ADCON0 directly use compiler defines
; 161: Define ADC_CLOCK = 3 'Use A/D with internal RC clock
; 162: Define ADC_SAMPLEUS = 20 'default value is 20
; 163: ADCON1 = %10100000 'set right shifted, clock divide disabled, Vref+ AVss
	MOVLW 0xA0
	MOVWF 0x1F
; 164: 
; 165: Hseropen 57600
;       Exact baud rate: 56818
;       Baud rate error: 782 (1.35%)
	MOVLW 0x0A
	MOVWF SPBRG
	BSF TRISB,2
	BSF TRISB,5
	MOVLW 0x24
	MOVWF TXSTA
	BCF STATUS,RP0
	MOVLW 0x90
	MOVWF RCSTA
; 166: 
; 167: WaitMs 1000 'just to let things settle down
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	BCF PCLATH,3
	BCF PCLATH,4
	CALL W001
; 168: 
; 169: mycmd = 0 'initialize some variables
	CLRF 0x32
; 170: dnib = 1
	BSF 0x30,0
; 171: dcnt = 0
	CLRF 0x33
; 172: mymax(0) = maxb0 'set maximums
	MOVLW 0x31
	MOVWF 0x48
; 173: mymax(1) = maxb1
	MOVLW 0x4F
	MOVWF 0x49
; 174: mymax(2) = maxb2
	MOVLW 0x5F
	MOVWF 0x4A
; 175: mymax(3) = maxb3
	MOVLW 0x5F
	MOVWF 0x4B
; 176: bptr = 0 'current block pointer
	CLRF 0x4C
; 177: aptr = 0 'current address in block pointer
	CLRF 0x4D
; 178: tempstr = 0
	CLRF 0x46
; 179: tempnxt = 0
	CLRF 0x47
; 180: 
; 181: loop: 
L0001:
; 182: 
; 183: If RCSTA.OERR Then 'check for serial overrun and clear if found
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS 0x18,1
	GOTO L0020
; 184: RCSTA.CREN = 0
	BCF 0x18,4
; 185: RCSTA.CREN = 1
	BSF 0x18,4
; 186: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0021
L0020:	MOVLW 0x1F
	ANDWF STATUS,F
; 187: Hserget mychar 'get the character if present
	CLRW
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS PIR1,RCIF
	GOTO L0022
	MOVF RCREG,W
L0022:
	MOVWF 0x3B
; 188: If mychar > 0 Then 'see if we got one
	MOVF 0x3B,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0023
; 189: Select Case mychar 'parse it
; 190: Case 0x57 'W
	MOVF 0x3B,W
	SUBLW 0x57
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0024
; 191: dcnt = 0 'new command reset data
	CLRF 0x33
; 192: dnib = 1
	BSF 0x30,0
; 193: mycmd = 1 'set cmd to i2c write
	MOVLW 0x01
	MOVWF 0x32
; 194: Case 0x52 'R
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0025
L0024:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x52
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0026
; 195: dcnt = 0 'new command reset data
	CLRF 0x33
; 196: dnib = 1
	BSF 0x30,0
; 197: mycmd = 2 'set cmd to i2c read
	MOVLW 0x02
	MOVWF 0x32
; 198: Case 0x56 'V
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0027
L0026:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x56
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0028
; 199: dcnt = 0 'new command reset data
	CLRF 0x33
; 200: dnib = 1
	BSF 0x30,0
; 201: mycmd = 3 'set cmd to Analog in
	MOVLW 0x03
	MOVWF 0x32
; 202: Case 0x3f '?
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0029
L0028:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x3F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0030
; 203: dcnt = 0 'new command reset data
	CLRF 0x33
; 204: dnib = 1
	BSF 0x30,0
; 205: mycmd = 4 'set cmd to help
	MOVLW 0x04
	MOVWF 0x32
; 206: Case 0x50 'P
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0031
L0030:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x50
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0032
; 207: dcnt = 0 'new command reset data
	CLRF 0x33
; 208: dnib = 1
	BSF 0x30,0
; 209: mycmd = 5 'set cmd to PWM
	MOVLW 0x05
	MOVWF 0x32
; 210: Case 0x46 'F
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0033
L0032:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x46
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0034
; 211: dcnt = 0 'new command reset data
	CLRF 0x33
; 212: dnib = 1
	BSF 0x30,0
; 213: mycmd = 6 'set cmd to frequency
	MOVLW 0x06
	MOVWF 0x32
; 214: Case 0x42 'B
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0035
L0034:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x42
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0036
; 215: dcnt = 0 'new command reset data
	CLRF 0x33
; 216: dnib = 1
	BSF 0x30,0
; 217: mycmd = 7 'set cmd to frequency
	MOVLW 0x07
	MOVWF 0x32
; 218: Case 0x44 'D
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0037
L0036:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x44
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0038
; 219: dcnt = 0 'new command reset data
	CLRF 0x33
; 220: dnib = 1
	BSF 0x30,0
; 221: mycmd = 8 'set cmd to write DDS
	MOVLW 0x08
	MOVWF 0x32
; 222: Case 0x43 'C
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0039
L0038:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x43
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0040
; 223: dcnt = 0 'new command reset data
	CLRF 0x33
; 224: dnib = 1
	BSF 0x30,0
; 225: mycmd = 9 'set cmd to capture data
	MOVLW 0x09
	MOVWF 0x32
; 226: 
; 227: 
; 228: Case 0x0a '<lf> end of input from pc so execute command
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0041
L0040:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x0A
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0042
; 229: Hserout 0x13 'send XOFF to stop more data frpm PC while working
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x13
	CALL HS01
; 230: Select Case mycmd
; 231: Case 1 'it is a I2C write
	MOVF 0x32,W
	SUBLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0043
; 232: If dcnt > 1 Then 'we at least have the address and one byte to write
	MOVF 0x33,W
	SUBLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0044
; 233: sladdr = mydata(0)
	MOVF 0x4E,W
	MOVWF 0x31
; 234: sladdr.0 = 0 'just to be sure it is a write address
	BCF 0x31,0
; 235: I2CPrepare sda, scl
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x02
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,1
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
	CALL IC41
; 236: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 237: I2CSend sladdr
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 238: WaitUs 80 'match the delay with the read
	MOVLW 0x50
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 239: For mycnt = 2 To dcnt
	MOVLW 0x02
	MOVWF 0x39
L0045:
	MOVF 0x39,W
	SUBWF 0x33,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0046
; 240: rdata = mycnt - 1
	MOVLW 0x01
	SUBWF 0x39,W
	MOVWF 0x34
; 241: I2CSend mydata(rdata)
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x34,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	CALL IC01
; 242: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0045
L0046:	MOVLW 0x1F
	ANDWF STATUS,F
; 243: I2CStop
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
; 244: Else 'No data
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0047
L0044:	MOVLW 0x1F
	ANDWF STATUS,F
; 245: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 246: Endif
L0047:	MOVLW 0x1F
	ANDWF STATUS,F
; 247: dcnt = 0 'all sent
	CLRF 0x33
; 248: Hserout "OK", CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x4F
	CALL HS01
	MOVLW 0x4B
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 249: Case 2 'it is a I2C read
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0048
L0043:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x02
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0049
; 250: Select Case dcnt
; 251: Case 1 'just the address ie. get one byte
	MOVF 0x33,W
	SUBLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0050
; 252: sladdr = mydata(0) 'first data byte will be the address
	MOVF 0x4E,W
	MOVWF 0x31
; 253: sladdr.0 = 1 'ensure lsb = 1 to indicate read
	BSF 0x31,0
; 254: rdata = 0 'clear it before reading
	CLRF 0x34
; 255: I2CRead1 sda, scl, sladdr, rdata 'Read from the tuner
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x02
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,1
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
	CALL IC41
	CALL IC31
	MOVF 0x31,W
	IORLW 0x01
	CALL IC01
	CALL IC11
	MOVWF 0x34
	CALL IC41
; 256: Hserout "R"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x52
	CALL HS01
; 257: mysubval = sladdr
	MOVF 0x31,W
	MOVWF 0x37
; 258: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 259: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 260: mysubval = rdata
	MOVF 0x34,W
	MOVWF 0x37
; 261: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 262: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 263: Case 2 'the address and a number of bytes
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0051
L0050:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	SUBLW 0x02
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0052
; 264: If mydata(1) > 0 Then 'don't get 0 bytes
	MOVF 0x4F,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0053
; 265: sladdr = mydata(0) 'first data byte will be the address
	MOVF 0x4E,W
	MOVWF 0x31
; 266: sladdr.0 = 1 'ensure lsb = 1 to indicate read
	BSF 0x31,0
; 267: Hserout "R"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x52
	CALL HS01
; 268: I2CPrepare sda, scl
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x02
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,1
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
	CALL IC41
; 269: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 270: I2CSend sladdr 'the address
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 271: mysubval = sladdr 'this also is a delay between i2c bytes
	MOVF 0x31,W
	MOVWF 0x37
; 272: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 273: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 274: For mycnt = 2 To mydata(1) 'get number of bytes less 1
	MOVLW 0x02
	MOVWF 0x39
L0054:
	MOVF 0x39,W
	SUBWF 0x4F,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0055
; 275: I2CReceiveAck mysubval
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC13
	MOVWF 0x37
; 276: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 277: Hserout ","
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x2C
	CALL HS01
; 278: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0054
L0055:	MOVLW 0x1F
	ANDWF STATUS,F
; 279: I2CRecN mysubval 'get last byte with a nak
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC11
	MOVWF 0x37
; 280: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 281: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 282: I2CStop
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
; 283: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0056
L0053:	MOVLW 0x1F
	ANDWF STATUS,F
; 284: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 285: Endif
L0056:	MOVLW 0x1F
	ANDWF STATUS,F
; 286: Case 3 'the address, byte subaddress and a number of bytes
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0057
L0052:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	SUBLW 0x03
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0058
; 287: If mydata(2) > 0 Then 'don't get 0 bytes
	MOVF 0x50,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0059
; 288: sladdr = mydata(0) 'first data byte will be the address
	MOVF 0x4E,W
	MOVWF 0x31
; 289: Hserout "R"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x52
	CALL HS01
; 290: I2CPrepare sda, scl
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x02
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,1
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
	CALL IC41
; 291: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 292: sladdr.0 = 0 'ensure lsb = 0 to indicate subaddress to follow
	BCF 0x31,0
; 293: I2CSend sladdr 'the address
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 294: mysubval = sladdr 'this also is a delay between i2c bytes
	MOVF 0x31,W
	MOVWF 0x37
; 295: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 296: I2CSend mydata(1) 'the sub address
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x4F,W
	CALL IC01
; 297: mysubval = mydata(1) 'this also is a delay between i2c bytes
	MOVF 0x4F,W
	MOVWF 0x37
; 298: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 299: sladdr.0 = 1 'ensure lsb = 1 to indicate read
	BSF 0x31,0
; 300: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 301: I2CSend sladdr 'the address with read bit
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 302: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 303: For mycnt = 2 To mydata(2) 'get number of bytes less 1
	MOVLW 0x02
	MOVWF 0x39
L0060:
	MOVF 0x39,W
	SUBWF 0x50,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0061
; 304: I2CReceiveAck mysubval
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC13
	MOVWF 0x37
; 305: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 306: Hserout ","
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x2C
	CALL HS01
; 307: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0060
L0061:	MOVLW 0x1F
	ANDWF STATUS,F
; 308: I2CRecN mysubval 'get last byte with a nak
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC11
	MOVWF 0x37
; 309: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 310: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 311: I2CStop
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
; 312: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0062
L0059:	MOVLW 0x1F
	ANDWF STATUS,F
; 313: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 314: Endif
L0062:	MOVLW 0x1F
	ANDWF STATUS,F
; 315: Case 4 'the address, word subaddress and a number of bytes
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0063
L0058:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	SUBLW 0x04
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0064
; 316: If mydata(3) > 0 Then 'don't get 0 bytes
	MOVF 0x51,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0065
; 317: sladdr = mydata(0) 'first data byte will be the address
	MOVF 0x4E,W
	MOVWF 0x31
; 318: Hserout "R"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x52
	CALL HS01
; 319: I2CPrepare sda, scl
	MOVLW 0x06
	MOVWF SDA_PORT
	MOVLW 0x02
	MOVWF SDA_BIT
	BSF STATUS,RP0
	BCF TRISB,1
	BCF STATUS,RP0
	MOVLW 0x06
	MOVWF SCL_PORT
	MOVLW 0x10
	MOVWF SCL_BIT
	BSF STATUS,RP0
	BCF TRISB,4
	BCF STATUS,RP0
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
	CALL IC41
; 320: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 321: sladdr.0 = 0 'ensure lsb = 0 to indicate subaddress to follow
	BCF 0x31,0
; 322: I2CSend sladdr 'the address
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 323: mysubval = sladdr 'this also is a delay between i2c bytes
	MOVF 0x31,W
	MOVWF 0x37
; 324: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 325: I2CSend mydata(1) 'the first byte of subaddress
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x4F,W
	CALL IC01
; 326: mysubval = mydata(1) 'this also is a delay between i2c bytes
	MOVF 0x4F,W
	MOVWF 0x37
; 327: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 328: I2CSend mydata(2) 'the second byte of subaddress
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x50,W
	CALL IC01
; 329: mysubval = mydata(2) 'this also is a delay between i2c bytes
	MOVF 0x50,W
	MOVWF 0x37
; 330: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 331: I2CStop
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
; 332: sladdr.0 = 1 'ensure lsb = 1 to indicate read
	BSF 0x31,0
; 333: I2CStart
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC31
; 334: I2CSend sladdr 'the address with read bit
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x31,W
	CALL IC01
; 335: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 336: For mycnt = 2 To mydata(3) 'get number of bytes less 1
	MOVLW 0x02
	MOVWF 0x39
L0066:
	MOVF 0x39,W
	SUBWF 0x51,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0067
; 337: I2CReceiveAck mysubval
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC13
	MOVWF 0x37
; 338: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 339: Hserout ","
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x2C
	CALL HS01
; 340: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0066
L0067:	MOVLW 0x1F
	ANDWF STATUS,F
; 341: I2CRecN mysubval 'get last byte with a nak
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC11
	MOVWF 0x37
; 342: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 343: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 344: I2CStop
	BCF PCLATH,3
	BCF PCLATH,4
	CALL IC41
; 345: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0068
L0065:	MOVLW 0x1F
	ANDWF STATUS,F
; 346: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 347: Endif
L0068:	MOVLW 0x1F
	ANDWF STATUS,F
; 348: Case Else 'too much or too little
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0069
L0064:	MOVLW 0x1F
	ANDWF STATUS,F
; 349: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 350: EndSelect
L0069:	MOVLW 0x1F
	ANDWF STATUS,F
L0063:	MOVLW 0x1F
	ANDWF STATUS,F
L0057:	MOVLW 0x1F
	ANDWF STATUS,F
L0051:	MOVLW 0x1F
	ANDWF STATUS,F
; 351: Case 3 'it is 10 bit Analog Voltage read
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0070
L0049:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x03
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0071
; 352: sladdr = mydata(0) 'get the port to read
	MOVF 0x4E,W
	MOVWF 0x31
; 353: Select Case dcnt
; 354: Case < 1
	MOVLW 0x01
	SUBWF 0x33,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0072
; 355: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 356: Case 1 'if there is just a port then do it
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0073
L0072:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	SUBLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0074
; 357: Gosub dovoltsall
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0005
; 358: Case 2 'if there is a port and a repeat count do it many times
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0075
L0074:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x33,W
	SUBLW 0x02
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0076
; 359: For mycnt = 1 To mydata(1)
	MOVLW 0x01
	MOVWF 0x39
L0077:
	MOVF 0x39,W
	SUBWF 0x4F,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0078
; 360: Gosub dovoltsall
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0005
; 361: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0077
L0078:	MOVLW 0x1F
	ANDWF STATUS,F
; 362: Case Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0079
L0076:	MOVLW 0x1F
	ANDWF STATUS,F
; 363: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 364: EndSelect
L0079:	MOVLW 0x1F
	ANDWF STATUS,F
L0075:	MOVLW 0x1F
	ANDWF STATUS,F
L0073:	MOVLW 0x1F
	ANDWF STATUS,F
; 365: Case 4 'it is a help "?"
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0080
L0071:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x04
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0081
; 366: Hserout "VK3DIP Simple Serial IO V4.1E", CrLf 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x56
	CALL HS01
	MOVLW 0x4B
	CALL HS01
	MOVLW 0x33
	CALL HS01
	MOVLW 0x44
	CALL HS01
	MOVLW 0x49
	CALL HS01
	MOVLW 0x50
	CALL HS01
	MOVLW 0x20
	CALL HS01
	MOVLW 0x53
	CALL HS01
	MOVLW 0x69
	CALL HS01
	MOVLW 0x6D
	CALL HS01
	MOVLW 0x70
	CALL HS01
	MOVLW 0x6C
	CALL HS01
	MOVLW 0x65
	CALL HS01
	MOVLW 0x20
	CALL HS01
	MOVLW 0x53
	CALL HS01
	MOVLW 0x65
	CALL HS01
	MOVLW 0x72
	CALL HS01
	MOVLW 0x69
	CALL HS01
	MOVLW 0x61
	CALL HS01
	MOVLW 0x6C
	CALL HS01
	MOVLW 0x20
	CALL HS01
	MOVLW 0x49
	CALL HS01
	MOVLW 0x4F
	CALL HS01
	MOVLW 0x20
	CALL HS01
	MOVLW 0x56
	CALL HS01
	MOVLW 0x34
	CALL HS01
	MOVLW 0x2E
	CALL HS01
	MOVLW 0x31
	CALL HS01
	MOVLW 0x45
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 367: Case 5 'it is PWM out
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0082
L0081:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x05
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0083
; 368: If dcnt > 0 Then 'we at least have the duty cycle
	MOVF 0x33,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0084
; 369: rdata = mydata(0)
	MOVF 0x4E,W
	MOVWF 0x34
; 370: If rdata > 0 Then
	MOVF 0x34,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0085
; 371: PWMon 1, 9 '8 bit res 39.06Khz at 10M xtal
	MOVLW 0x3F
	BSF STATUS,RP0
	MOVWF PR2
	BCF 0x06,3
	BCF STATUS,RP0
	CLRF CCPR1L
	BCF CCP1CON,CCP1X
	BCF CCP1CON,CCP1Y
	BCF T2CON,T2CKPS0
	BCF T2CON,T2CKPS1
	BSF T2CON,TMR2ON
	MOVLW 0x0C
	IORWF CCP1CON,F
; 372: PWMduty 1, mydata(0)
	MOVF 0x4E,W
	MOVWF R0L
	BTFSC R0L,0
	BSF CCP1CON,CCP1Y
	BTFSS R0L,0
	BCF CCP1CON,CCP1Y
	BTFSC R0L,1
	BSF CCP1CON,CCP1X
	BTFSS R0L,1
	BCF CCP1CON,CCP1X
	BCF STATUS,C
	RRF R0L,F
	BCF STATUS,C
	RRF R0L,W
	MOVWF CCPR1L
; 373: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0086
L0085:	MOVLW 0x1F
	ANDWF STATUS,F
; 374: PWMoff 1
	CLRF CCP1CON
	BCF T2CON,TMR2ON
; 375: Endif
L0086:	MOVLW 0x1F
	ANDWF STATUS,F
; 376: Hserout "OK", CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x4F
	CALL HS01
	MOVLW 0x4B
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 377: Else 'no data
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0087
L0084:	MOVLW 0x1F
	ANDWF STATUS,F
; 378: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 379: Endif
L0087:	MOVLW 0x1F
	ANDWF STATUS,F
; 380: Case 6 'it is Frequency
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0088
L0083:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x06
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0089
; 381: If dcnt > 0 Then 'we at least have something for the gate time
	MOVF 0x33,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0090
; 382: rdata = mydata(0)
	MOVF 0x4E,W
	MOVWF 0x34
; 383:  'To tweek gate times vary myd1, each myd1 adds 11 instrutions
; 384: Select Case rdata
; 385: Case 0x01 'Gate time = 0.1 seconds
	MOVF 0x34,W
	SUBLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0091
; 386: Gosub getfreq2
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0010
; 387: Case 0x10 'Gate time = 1 seconds
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0092
L0091:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x10
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0093
; 388: Gosub getfreq1
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0009
; 389: Case Else 'default to 1 second
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0094
L0093:	MOVLW 0x1F
	ANDWF STATUS,F
; 390: Gosub getfreq1
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0009
; 391: EndSelect
L0094:	MOVLW 0x1F
	ANDWF STATUS,F
L0092:	MOVLW 0x1F
	ANDWF STATUS,F
; 392: Hserout "F"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x46
	CALL HS01
; 393: mysubval = rdata
	MOVF 0x34,W
	MOVWF 0x37
; 394: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 395: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 396: mysubval = myb2
	MOVF 0x41,W
	MOVWF 0x37
; 397: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 398: mysubval = myb1
	MOVF 0x42,W
	MOVWF 0x37
; 399: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 400: mysubval = myb0
	MOVF 0x43,W
	MOVWF 0x37
; 401: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 402: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 403: Else 'no data
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0095
L0090:	MOVLW 0x1F
	ANDWF STATUS,F
; 404: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 405: Endif
L0095:	MOVLW 0x1F
	ANDWF STATUS,F
; 406: 
; 407: Case 7 'it is digital Bits out on RB7,RB3,RA4
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0096
L0089:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x07
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0097
; 408: If dcnt > 0 Then 'we at least have the byte out
	MOVF 0x33,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0098
; 409: rdata = mydata(0)
	MOVF 0x4E,W
	MOVWF 0x34
; 410: If rdata < 8 Then
	MOVLW 0x08
	SUBWF 0x34,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0099
; 411: Gosub bitout
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0008
; 412: Hserout "OK", CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x4F
	CALL HS01
	MOVLW 0x4B
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 413: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0100
L0099:	MOVLW 0x1F
	ANDWF STATUS,F
; 414: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 415: Endif
L0100:	MOVLW 0x1F
	ANDWF STATUS,F
; 416: Else 'no data
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0101
L0098:	MOVLW 0x1F
	ANDWF STATUS,F
; 417: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 418: Endif
L0101:	MOVLW 0x1F
	ANDWF STATUS,F
; 419: Case 8 'it is DDS style write
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0102
L0097:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x08
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0103
; 420: If dcnt > 0 Then 'we at least have one byte to send
	MOVF 0x33,W
	SUBLW 0x00
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0104
; 421: sladdr = dcnt - 1
	MOVLW 0x01
	SUBWF 0x33,W
	MOVWF 0x31
; 422: gend1 = 0 'clock low to start
	BCF 0x05,4
; 423: gend3 = 0 'FQ_UD to low to start
	BCF 0x06,7
; 424:  'send as many bytes as we have got bit at a time
; 425:  'Start with last entered byte first
; 426:  'sendbyte sends bit 0 first
; 427:  'ie bits will be sent right to left
; 428: For mycnt = sladdr To 0 Step -1
	MOVF 0x31,W
	MOVWF 0x39
L0105:
	MOVLW 0x00
	SUBWF 0x39,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0106
; 429: myparam = mydata(mycnt)
	MOVF 0x39,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x36
; 430: Gosub sendbyte
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0011
; 431: Next mycnt
	MOVLW 0x01
	SUBWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0105
L0106:	MOVLW 0x1F
	ANDWF STATUS,F
; 432: gend3 = 1 'toggle FQ_UD to latch the data.
	BSF 0x06,7
; 433: WaitUs 10
	MOVLW 0x0A
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 434: gend3 = 0
	BCF 0x06,7
; 435: WaitUs 10
	MOVLW 0x0A
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 436: Hserout "OK", CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x4F
	CALL HS01
	MOVLW 0x4B
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 437: 
; 438: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0107
L0104:	MOVLW 0x1F
	ANDWF STATUS,F
; 439: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 440: Endif
L0107:	MOVLW 0x1F
	ANDWF STATUS,F
; 441: Case 9 'it is a 10 bit Analog Voltage capture
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0108
L0103:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x32,W
	SUBLW 0x09
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0109
; 442: 
; 443: If dcnt = 2 Then 'All ok got port and delay
	MOVF 0x33,W
	SUBLW 0x02
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0110
; 444: sladdr = mydata(0) 'get the port to read
	MOVF 0x4E,W
	MOVWF 0x31
; 445: myp2 = mydata(1) 'save the required delay
	MOVF 0x4F,W
	MOVWF 0x38
; 446: If sladdr < 2 Then 'all OK valid port
	MOVLW 0x02
	SUBWF 0x31,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0111
; 447: bptr = 0 'set to begining of buffers
	CLRF 0x4C
; 448: aptr = 0
	CLRF 0x4D
; 449: tempstr = 0
	CLRF 0x46
; 450: tempnxt = 0
	CLRF 0x47
; 451: mycmd = 0 'we are using the buffer so stop reuse
	CLRF 0x32
; 452: TRISB.1 = 1 'make sure its an input
	BSF STATUS,RP0
	BSF 0x06,1
	BCF STATUS,RP0
; 453: While Not sda 'wait till sda is high
L0112:
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC 0x06,1
	GOTO L0113
; 454: Wend 'these will wait for a high to low transition
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0112
L0113:	MOVLW 0x1F
	ANDWF STATUS,F
; 455: While sda 'now wait till sda line goes low
L0114:
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS 0x06,1
	GOTO L0115
; 456: Wend 'may hang for ever.
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0114
L0115:	MOVLW 0x1F
	ANDWF STATUS,F
; 457: While bptr <> 9 'keep going till buffer full
L0116:
	MOVF 0x4C,W
	SUBLW 0x09
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,Z
	GOTO L0117
; 458: Adcin sladdr, myvolts
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	BCF STATUS,RP0
	MOVF 0x31,W
	MOVWF R0L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x3C
	MOVF ADRESH,W
	MOVWF 0x3D
; 459: mybyte = myvolts.LB
	MOVF 0x3C,W
	MOVWF 0x45
; 460: Gosub addbyte
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0013
; 461: mydbit = myvolts.HB
	MOVF 0x3D,W
	MOVWF 0x44
; 462: Gosub adddb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0012
; 463: For mycnt = 0 To myp2 'Approx 100us steps
	CLRF 0x39
L0118:
	MOVF 0x39,W
	SUBWF 0x38,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0119
; 464: WaitUs 100 'wait for requested intersample delay
	MOVLW 0x64
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 465: Next mycnt
	MOVLW 0x01
	ADDWF 0x39,F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0118
L0119:	MOVLW 0x1F
	ANDWF STATUS,F
; 466: Wend
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0116
L0117:	MOVLW 0x1F
	ANDWF STATUS,F
; 467:  'got them all send them out
; 468: bptr = 0 'set to begining of buffers
	CLRF 0x4C
; 469: aptr = 0
	CLRF 0x4D
; 470: tempstr = 0
	CLRF 0x46
; 471: tempnxt = 0
	CLRF 0x47
; 472: Hserout "C"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x43
	CALL HS01
; 473: mysubval = sladdr
	MOVF 0x31,W
	MOVWF 0x37
; 474: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 475: Hserout "," 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x2C
	CALL HS01
; 476: mysubval = myp2
	MOVF 0x38,W
	MOVWF 0x37
; 477: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 478: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 479: Hserout "[" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x5B
	CALL HS01
; 480: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 481: While bptr <> 9 'keep going till buffer empty
L0120:
	MOVF 0x4C,W
	SUBLW 0x09
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,Z
	GOTO L0121
; 482: Gosub getbyte
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0015
; 483: Gosub getdb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0014
; 484: mysubval = mydbit
	MOVF 0x44,W
	MOVWF 0x37
; 485: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 486: mysubval = mybyte
	MOVF 0x45,W
	MOVWF 0x37
; 487: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 488: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 489: Wend
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0120
L0121:	MOVLW 0x1F
	ANDWF STATUS,F
; 490: Hserout "]"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x5D
	CALL HS01
; 491: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 492: Else 'invalid port
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0122
L0111:	MOVLW 0x1F
	ANDWF STATUS,F
; 493: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 494: Endif
L0122:	MOVLW 0x1F
	ANDWF STATUS,F
; 495: 
; 496: Else 'otherwise it is an error
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0123
L0110:	MOVLW 0x1F
	ANDWF STATUS,F
; 497: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 498: Endif
L0123:	MOVLW 0x1F
	ANDWF STATUS,F
; 499: 
; 500: EndSelect 'do nothing for unknown commands
L0109:	MOVLW 0x1F
	ANDWF STATUS,F
L0108:	MOVLW 0x1F
	ANDWF STATUS,F
L0102:	MOVLW 0x1F
	ANDWF STATUS,F
L0096:	MOVLW 0x1F
	ANDWF STATUS,F
L0088:	MOVLW 0x1F
	ANDWF STATUS,F
L0082:	MOVLW 0x1F
	ANDWF STATUS,F
L0080:	MOVLW 0x1F
	ANDWF STATUS,F
L0070:	MOVLW 0x1F
	ANDWF STATUS,F
L0048:	MOVLW 0x1F
	ANDWF STATUS,F
; 501: Hserout 0x11 'send XON to say all done to the PC and start sending.
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x11
	CALL HS01
; 502: Case > 0x66 'everything above f not already trapped is an error
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0124
L0042:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x66
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0125
; 503: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 504: Case > 0x60 'assume a and up ( > ')not already trapped is a Hex charin
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0126
L0125:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x60
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0127
; 505: myparam = mychar - 87
	MOVLW 0x57
	SUBWF 0x3B,W
	MOVWF 0x36
; 506: Gosub setdata
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0006
; 507: Case > 0x39 'everything above 9 not already trapped is an error
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0128
L0127:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x39
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0129
; 508: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 509: Case > 0x2f 'assume anything left 0 and up ( > /) is a hex numin
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0130
L0129:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x3B,W
	SUBLW 0x2F
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0131
; 510: myparam = mychar - 48
	MOVLW 0x30
	SUBWF 0x3B,W
	MOVWF 0x36
; 511: Gosub setdata
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0006
; 512: EndSelect 'anything else left ie. below 0 is whitespace and ignored.
L0131:	MOVLW 0x1F
	ANDWF STATUS,F
L0130:	MOVLW 0x1F
	ANDWF STATUS,F
L0128:	MOVLW 0x1F
	ANDWF STATUS,F
L0126:	MOVLW 0x1F
	ANDWF STATUS,F
L0124:	MOVLW 0x1F
	ANDWF STATUS,F
L0041:	MOVLW 0x1F
	ANDWF STATUS,F
L0039:	MOVLW 0x1F
	ANDWF STATUS,F
L0037:	MOVLW 0x1F
	ANDWF STATUS,F
L0035:	MOVLW 0x1F
	ANDWF STATUS,F
L0033:	MOVLW 0x1F
	ANDWF STATUS,F
L0031:	MOVLW 0x1F
	ANDWF STATUS,F
L0029:	MOVLW 0x1F
	ANDWF STATUS,F
L0027:	MOVLW 0x1F
	ANDWF STATUS,F
L0025:	MOVLW 0x1F
	ANDWF STATUS,F
; 513: Endif
L0023:	MOVLW 0x1F
	ANDWF STATUS,F
; 514: Endif
L0021:	MOVLW 0x1F
	ANDWF STATUS,F
; 515: Goto loop
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0001
; 516: 
; 517: End
	BCF PCLATH,3
	BCF PCLATH,4
L0132:	GOTO L0132
; 518: tohex: 
L0002:
; 519: If myparam < 10 Then
	MOVLW 0x0A
	SUBWF 0x36,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0133
; 520: myhex = 0x30 + myparam
	MOVLW 0x30
	ADDWF 0x36,W
	MOVWF 0x35
; 521: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0134
L0133:	MOVLW 0x1F
	ANDWF STATUS,F
; 522: myhex = 0x57 + myparam
	MOVLW 0x57
	ADDWF 0x36,W
	MOVWF 0x35
; 523: Endif
L0134:	MOVLW 0x1F
	ANDWF STATUS,F
; 524: Return
	RETURN
; 525: writebyte: 
L0003:
; 526: myparam = mysubval And hinib
	MOVF 0x37,W
	MOVWF R0L
	MOVLW 0xF0
	ANDWF R0L,W
	MOVWF 0x36
; 527: myparam = ShiftRight(myparam, 4) 'get high nibble
	MOVF 0x36,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x04
	BCF PCLATH,3
	BCF PCLATH,4
	CALL SR00
	MOVWF 0x36
; 528: Gosub tohex
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0002
; 529: Hserout myhex
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x35,W
	CALL HS01
; 530: myparam = mysubval And lonib 'get low nibble of high byte
	MOVF 0x37,W
	MOVWF R0L
	MOVLW 0x0F
	ANDWF R0L,W
	MOVWF 0x36
; 531: Gosub tohex
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0002
; 532: Hserout myhex
	BCF PCLATH,3
	BCF PCLATH,4
	MOVF 0x35,W
	CALL HS01
; 533: Return
	RETURN
; 534: dovolts: 
L0004:
; 535: Adcin myp2, myvolts
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	BCF STATUS,RP0
	MOVF 0x38,W
	MOVWF R0L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x3C
	MOVF ADRESH,W
	MOVWF 0x3D
; 536: Hserout "V"
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x56
	CALL HS01
; 537: mysubval = myp2
	MOVF 0x38,W
	MOVWF 0x37
; 538: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 539: Hserout "=" 'send back to the PC the result
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x3D
	CALL HS01
; 540: mysubval = myvolts.HB
	MOVF 0x3D,W
	MOVWF 0x37
; 541: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 542: mysubval = myvolts.LB
	MOVF 0x3C,W
	MOVWF 0x37
; 543: Gosub writebyte
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0003
; 544: Hserout CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 545: Return
	RETURN
; 546: dovoltsall: 
L0005:
; 547: Select Case sladdr
; 548: Case < 0x03
	MOVLW 0x03
	SUBWF 0x31,W
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0135
; 549: myp2 = sladdr
	MOVF 0x31,W
	MOVWF 0x38
; 550: Gosub dovolts
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0004
; 551: Case 0x03 'we want them all
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0136
L0135:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x31,W
	SUBLW 0x03
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0137
; 552: myp2 = 0x00
	CLRF 0x38
; 553: Gosub dovolts
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0004
; 554: myp2 = 0x01
	MOVLW 0x01
	MOVWF 0x38
; 555: Gosub dovolts
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0004
; 556: myp2 = 0x02
	MOVLW 0x02
	MOVWF 0x38
; 557: Gosub dovolts
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0004
; 558: Case Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0138
L0137:	MOVLW 0x1F
	ANDWF STATUS,F
; 559: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 560: EndSelect
L0138:	MOVLW 0x1F
	ANDWF STATUS,F
L0136:	MOVLW 0x1F
	ANDWF STATUS,F
; 561: Return
	RETURN
; 562: setdata:  'add the received nibble to the appropriate data byte.
L0006:
; 563: If dcnt > maxb0 Then 'if we get more than max siz of first databuffer start again and ignore data
	MOVF 0x33,W
	SUBLW 0x31
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,C
	GOTO L0139
; 564: Gosub cmderror
	BCF PCLATH,3
	BCF PCLATH,4
	CALL L0007
; 565: Else
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0140
L0139:	MOVLW 0x1F
	ANDWF STATUS,F
; 566: If dnib Then 'do high nibble
	BCF PCLATH,3
	BCF PCLATH,4
	BTFSS 0x30,0
	GOTO L0141
; 567: mydata(dcnt) = mydata(dcnt) And lonib 'save lo nibble of data, clear hi
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	MOVWF R0L
	MOVLW 0x0F
	ANDWF R0L,W
	MOVWF R5L
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 568: myparam = ShiftLeft(myparam, 4) 'move param to hi nibble posn
	MOVF 0x36,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x04
	BCF PCLATH,3
	BCF PCLATH,4
	CALL SL00
	MOVWF 0x36
; 569: myparam = myparam And hinib 'ensure only hi nibble used
	MOVF 0x36,W
	MOVWF R0L
	MOVLW 0xF0
	ANDWF R0L,W
	MOVWF 0x36
; 570: mydata(dcnt) = mydata(dcnt) + myparam 'add hi nibble to data
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	ADDWF 0x36,W
	MOVWF R5L
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 571: dnib = 0 'lo nibble next
	BCF 0x30,0
; 572: Else 'do lo nibble
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0142
L0141:	MOVLW 0x1F
	ANDWF STATUS,F
; 573: mydata(dcnt) = mydata(dcnt) And hinib 'save hi nibble of data, clear lo
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	MOVWF R0L
	MOVLW 0xF0
	ANDWF R0L,W
	MOVWF R5L
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 574: myparam = myparam And lonib 'ensure only lo nibble used.
	MOVF 0x36,W
	MOVWF R0L
	MOVLW 0x0F
	ANDWF R0L,W
	MOVWF 0x36
; 575: mydata(dcnt) = mydata(dcnt) + myparam 'add lo nibble to data
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	ADDWF 0x36,W
	MOVWF R5L
	MOVF 0x33,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 576: dcnt = dcnt + 1 'finished this data byte ready for next
	MOVF 0x33,W
	ADDLW 0x01
	MOVWF 0x33
; 577: dnib = 1 'start at hi nibble
	BSF 0x30,0
; 578: Endif
L0142:	MOVLW 0x1F
	ANDWF STATUS,F
; 579: Endif
L0140:	MOVLW 0x1F
	ANDWF STATUS,F
; 580: Return
	RETURN
; 581: cmderror: 
L0007:
; 582: mycmd = 0
	CLRF 0x32
; 583: dnib = 1
	BSF 0x30,0
; 584: dcnt = 0
	CLRF 0x33
; 585: Hserout "Command Error", CrLf
	BCF PCLATH,3
	BCF PCLATH,4
	MOVLW 0x43
	CALL HS01
	MOVLW 0x6F
	CALL HS01
	MOVLW 0x6D
	CALL HS01
	MOVLW 0x6D
	CALL HS01
	MOVLW 0x61
	CALL HS01
	MOVLW 0x6E
	CALL HS01
	MOVLW 0x64
	CALL HS01
	MOVLW 0x20
	CALL HS01
	MOVLW 0x45
	CALL HS01
	MOVLW 0x72
	CALL HS01
	MOVLW 0x72
	CALL HS01
	MOVLW 0x6F
	CALL HS01
	MOVLW 0x72
	CALL HS01
	MOVLW 0x0D
	CALL HS01
	MOVLW 0x0A
	CALL HS01
; 586: Return
	RETURN
; 587: bitout:  'set bits out for generic digital bits out.
L0008:
; 588: Select Case rdata
; 589: Case 0
	MOVF 0x34,W
	SUBLW 0x00
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0143
; 590: gend1 = 0
	BCF 0x05,4
; 591: gend2 = 0
	BCF 0x06,3
; 592: gend3 = 0
	BCF 0x06,7
; 593: Case 1
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0144
L0143:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x01
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0145
; 594: gend1 = 1
	BSF 0x05,4
; 595: gend2 = 0
	BCF 0x06,3
; 596: gend3 = 0
	BCF 0x06,7
; 597: Case 2
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0146
L0145:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x02
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0147
; 598: gend1 = 0
	BCF 0x05,4
; 599: gend2 = 1
	BSF 0x06,3
; 600: gend3 = 0
	BCF 0x06,7
; 601: Case 3
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0148
L0147:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x03
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0149
; 602: gend1 = 1
	BSF 0x05,4
; 603: gend2 = 1
	BSF 0x06,3
; 604: gend3 = 0
	BCF 0x06,7
; 605: Case 4
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0150
L0149:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x04
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0151
; 606: gend1 = 0
	BCF 0x05,4
; 607: gend2 = 0
	BCF 0x06,3
; 608: gend3 = 1
	BSF 0x06,7
; 609: Case 5
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0152
L0151:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x05
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0153
; 610: gend1 = 1
	BSF 0x05,4
; 611: gend2 = 0
	BCF 0x06,3
; 612: gend3 = 1
	BSF 0x06,7
; 613: Case 6
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0154
L0153:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x06
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0155
; 614: gend1 = 0
	BCF 0x05,4
; 615: gend2 = 1
	BSF 0x06,3
; 616: gend3 = 1
	BSF 0x06,7
; 617: Case 7
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0156
L0155:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x34,W
	SUBLW 0x07
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0157
; 618: gend1 = 1
	BSF 0x05,4
; 619: gend2 = 1
	BSF 0x06,3
; 620: gend3 = 1
	BSF 0x06,7
; 621: EndSelect
L0157:	MOVLW 0x1F
	ANDWF STATUS,F
L0156:	MOVLW 0x1F
	ANDWF STATUS,F
L0154:	MOVLW 0x1F
	ANDWF STATUS,F
L0152:	MOVLW 0x1F
	ANDWF STATUS,F
L0150:	MOVLW 0x1F
	ANDWF STATUS,F
L0148:	MOVLW 0x1F
	ANDWF STATUS,F
L0146:	MOVLW 0x1F
	ANDWF STATUS,F
L0144:	MOVLW 0x1F
	ANDWF STATUS,F
; 622: Return
	RETURN
; 623: getfreq1: 
L0009:
; 624:  'Uses a one second gate ie 2500000 counts
; 625: 
; 626: myd1 = 180 'D1 changes 10 counts per number ie subtracting one from D1 subtracts 10 instruction cycles
	MOVLW 0xB4
	MOVWF 0x3E
; 627: myd2 = 210
	MOVLW 0xD2
	MOVWF 0x3F
; 628: myd3 = 4
	MOVLW 0x04
	MOVWF 0x40
; 629: T1CON = 0 'stop timer
	CLRF 0x10
; 630: INTCON = 0 'disable interupts
	CLRF 0x0B
; 631: PIR1 = 0
	CLRF 0x0C
; 632: PIE1 = 0
	BSF STATUS,RP0
	CLRF 0x0C
; 633: myb2 = 0 'clear counters
	BCF STATUS,RP0
	CLRF 0x41
; 634: myb1 = 0 'clear counters
	CLRF 0x42
; 635: myb0 = 0 'clear counters
	CLRF 0x43
; 636: TMR1H = 0
	CLRF 0x0F
; 637: TMR1L = 0
	CLRF 0x0E
; 638: T1CON = 0x06 'set for T1CLK in for async counter no prescale, gate currently shut
	MOVLW 0x06
	MOVWF 0x10
; 639: ASM:        movlw 0x1F 'Set to bank 00
	       movlw 0x1F
; 640: ASM:        andwf status,f
	       andwf status,f
; 641: ASM:        bsf 0x10,0 'open gate TMR1 started
	       bsf 0x10,0
; 642: ASM:d1loop1: decfsz myd1,F 'inner delay loop first time use initial value all others use 0=256
d1loop1:	decfsz myd1,F
; 643: ASM:        goto mycchk1
	       goto mycchk1
; 644: ASM:        goto d2loop1
	       goto d2loop1
; 645: ASM:mycchk1: btfss 0x0c,0 'look for an overflow
mycchk1:	btfss 0x0c,0
; 646: ASM:        goto mychkf1
	       goto mychkf1
; 647: ASM:        bcf 0x0c,0 'clear the overflow
	       bcf 0x0c,0
; 648: ASM:        incf myb2,F 'increment the overflow counter
	       incf myb2,F
; 649: ASM:        nop
	       nop
; 650: ASM:        goto d1loop1
	       goto d1loop1
; 651: ASM:mychkf1: nop 'not OF so equalize delay
mychkf1:	nop
; 652: ASM:        nop
	       nop
; 653: ASM:        goto d1loop1
	       goto d1loop1
; 654: ASM:d2loop1: decfsz myd2,F 'second level delay loop first time use initial value all others use 0=256
d2loop1:	decfsz myd2,F
; 655: ASM:        goto d1loop1
	       goto d1loop1
; 656: ASM:        decfsz myd3,F 'outer delay loop uses initial value
	       decfsz myd3,F
; 657: ASM:        goto d1loop1
	       goto d1loop1
; 658: ASM:        nop 'fine tuning
	       nop
; 659: ASM:        nop
	       nop
; 660: ASM:        nop
	       nop
; 661: ASM:        nop
	       nop
; 662: ASM:        nop
	       nop
; 663: ASM:        nop
	       nop
; 664: ASM:        bcf 0x10,0 'close gate, counter stopped
	       bcf 0x10,0
; 665: ASM:        btfss 0x0c,0 'check for a count/OF coming in while busy elsewhere
	       btfss 0x0c,0
; 666: ASM:        goto doneit1
	       goto doneit1
; 667: ASM:        incf myb2,F
	       incf myb2,F
; 668: ASM:doneit1: bcf 0x0c,0
doneit1:	bcf 0x0c,0
; 669: myb1 = TMR1H
	MOVF 0x0F,W
	MOVWF 0x42
; 670: myb0 = TMR1L
	MOVF 0x0E,W
	MOVWF 0x43
; 671: Return
	RETURN
; 672: getfreq2: 
L0010:
; 673:  'Uses a point one second gate ie 250000 counts
; 674: myd1 = 197 'D1 changes 10 counts per number ie subtracting one from D1 subtracts 10 instruction cycles
	MOVLW 0xC5
	MOVWF 0x3E
; 675: myd2 = 98
	MOVLW 0x62
	MOVWF 0x3F
; 676: myd3 = 1
	MOVLW 0x01
	MOVWF 0x40
; 677: T1CON = 0 'stop timer
	CLRF 0x10
; 678: INTCON = 0 'disable interupts
	CLRF 0x0B
; 679: PIR1 = 0
	CLRF 0x0C
; 680: PIE1 = 0
	BSF STATUS,RP0
	CLRF 0x0C
; 681: myb2 = 0 'clear counters
	BCF STATUS,RP0
	CLRF 0x41
; 682: myb1 = 0 'clear counters
	CLRF 0x42
; 683: myb0 = 0 'clear counters
	CLRF 0x43
; 684: TMR1H = 0
	CLRF 0x0F
; 685: TMR1L = 0
	CLRF 0x0E
; 686: T1CON = 0x06 'set for T1CLK in for async counter no prescale, gate currently shut
	MOVLW 0x06
	MOVWF 0x10
; 687: ASM:        movlw 0x1F 'Set to bank 00
	       movlw 0x1F
; 688: ASM:        andwf status,f
	       andwf status,f
; 689: ASM:        bsf 0x10,0 'open gate TMR1 started
	       bsf 0x10,0
; 690: ASM:d1loop2: decfsz myd1,F 'inner delay loop first time use initial value all others use 0=256
d1loop2:	decfsz myd1,F
; 691: ASM:        goto mycchk2
	       goto mycchk2
; 692: ASM:        goto d2loop2
	       goto d2loop2
; 693: ASM:mycchk2: btfss 0x0c,0 'look for an overflow
mycchk2:	btfss 0x0c,0
; 694: ASM:        goto mychkf2
	       goto mychkf2
; 695: ASM:        bcf 0x0c,0 'clear the overflow
	       bcf 0x0c,0
; 696: ASM:        incf myb2,F 'increment the overflow counter
	       incf myb2,F
; 697: ASM:        nop
	       nop
; 698: ASM:        goto d1loop2
	       goto d1loop2
; 699: ASM:mychkf2: nop 'not OF so equalize delay
mychkf2:	nop
; 700: ASM:        nop
	       nop
; 701: ASM:        goto d1loop2
	       goto d1loop2
; 702: ASM:d2loop2: decfsz myd2,F 'second level delay loop first time use initial value all others use 0=256
d2loop2:	decfsz myd2,F
; 703: ASM:        goto d1loop2
	       goto d1loop2
; 704: ASM:        decfsz myd3,F 'outer delay loop uses initial value
	       decfsz myd3,F
; 705: ASM:        goto d1loop2
	       goto d1loop2
; 706: ASM:        nop 'fine tuning
	       nop
; 707: ASM:        nop
	       nop
; 708: ASM:        bcf 0x10,0 'close gate, counter stopped
	       bcf 0x10,0
; 709: ASM:        btfss 0x0c,0 'check for a count/OF coming in while busy elsewhere
	       btfss 0x0c,0
; 710: ASM:        goto doneit2
	       goto doneit2
; 711: ASM:        incf myb2,F
	       incf myb2,F
; 712: ASM:doneit2: bcf 0x0c,0
doneit2:	bcf 0x0c,0
; 713: myb1 = TMR1H
	MOVF 0x0F,W
	MOVWF 0x42
; 714: myb0 = TMR1L
	MOVF 0x0E,W
	MOVWF 0x43
; 715: Return
	RETURN
; 716: sendbyte:  'DDS style send bits in byte myparam
L0011:
; 717: For mycnt2 = 0 To 7 'for all bits in byte
	CLRF 0x3A
L0158:
	MOVF 0x3A,W
	SUBLW 0x07
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0159
; 718: gend2 = myparam.0 'set data to bit 0 of byte to send
	BTFSC 0x36,0
	BSF 0x06,3
	BTFSS 0x36,0
	BCF 0x06,3
; 719: gend1 = 1 'toggle clock line
	BSF 0x05,4
; 720: WaitUs 10 'wait a bit
	MOVLW 0x0A
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 721: gend1 = 0
	BCF 0x05,4
; 722: WaitUs 10
	MOVLW 0x0A
	MOVWF R4L
	BCF PCLATH,3
	BCF PCLATH,4
	CALL X001
; 723: myparam = ShiftRight(myparam, 1) 'move next bit down
	MOVF 0x36,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x01
	BCF PCLATH,3
	BCF PCLATH,4
	CALL SR00
	MOVWF 0x36
; 724: Next mycnt2
	MOVLW 0x01
	ADDWF 0x3A,F
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,C
	GOTO L0158
L0159:	MOVLW 0x1F
	ANDWF STATUS,F
; 725: Return
	RETURN
; 726: adddb:  'Add DiBits to store from mydbit
L0012:
; 727: Select Case tempnxt
; 728: Case 0
	MOVF 0x47,W
	SUBLW 0x00
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0160
; 729: tempstr.0 = mydbit.0
	BTFSC 0x44,0
	BSF 0x46,0
	BTFSS 0x44,0
	BCF 0x46,0
; 730: tempstr.1 = mydbit.1
	BTFSC 0x44,1
	BSF 0x46,1
	BTFSS 0x44,1
	BCF 0x46,1
; 731: tempnxt = 2
	MOVLW 0x02
	MOVWF 0x47
; 732: Case 2
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0161
L0160:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x02
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0162
; 733: tempstr.2 = mydbit.0
	BTFSC 0x44,0
	BSF 0x46,2
	BTFSS 0x44,0
	BCF 0x46,2
; 734: tempstr.3 = mydbit.1
	BTFSC 0x44,1
	BSF 0x46,3
	BTFSS 0x44,1
	BCF 0x46,3
; 735: tempnxt = 4
	MOVLW 0x04
	MOVWF 0x47
; 736: Case 4
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0163
L0162:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x04
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0164
; 737: tempstr.4 = mydbit.0
	BTFSC 0x44,0
	BSF 0x46,4
	BTFSS 0x44,0
	BCF 0x46,4
; 738: tempstr.5 = mydbit.1
	BTFSC 0x44,1
	BSF 0x46,5
	BTFSS 0x44,1
	BCF 0x46,5
; 739: tempnxt = 6
	MOVLW 0x06
	MOVWF 0x47
; 740: Case 6
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0165
L0164:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x06
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0166
; 741: tempstr.6 = mydbit.0
	BTFSC 0x44,0
	BSF 0x46,6
	BTFSS 0x44,0
	BCF 0x46,6
; 742: tempstr.7 = mydbit.1
	BTFSC 0x44,1
	BSF 0x46,7
	BTFSS 0x44,1
	BCF 0x46,7
; 743: tempnxt = 0
	CLRF 0x47
; 744: myparam = tempstr
	MOVF 0x46,W
	MOVWF 0x36
; 745: tempstr = 0
	CLRF 0x46
; 746: If bptr <> 9 Then
	MOVF 0x4C,W
	SUBLW 0x09
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,Z
	GOTO L0167
; 747: Gosub storeit
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0017
; 748: Gosub incptr
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0016
; 749: Endif
L0167:	MOVLW 0x1F
	ANDWF STATUS,F
; 750: EndSelect
L0166:	MOVLW 0x1F
	ANDWF STATUS,F
L0165:	MOVLW 0x1F
	ANDWF STATUS,F
L0163:	MOVLW 0x1F
	ANDWF STATUS,F
L0161:	MOVLW 0x1F
	ANDWF STATUS,F
; 751: Return
	RETURN
; 752: addbyte:  'Add byte to store from mybyte
L0013:
; 753: 
; 754: mydbit.0 = mybyte.0
	BTFSC 0x45,0
	BSF 0x44,0
	BTFSS 0x45,0
	BCF 0x44,0
; 755: mydbit.1 = mybyte.1
	BTFSC 0x45,1
	BSF 0x44,1
	BTFSS 0x45,1
	BCF 0x44,1
; 756: Gosub adddb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0012
; 757: mydbit.0 = mybyte.2
	BTFSC 0x45,2
	BSF 0x44,0
	BTFSS 0x45,2
	BCF 0x44,0
; 758: mydbit.1 = mybyte.3
	BTFSC 0x45,3
	BSF 0x44,1
	BTFSS 0x45,3
	BCF 0x44,1
; 759: Gosub adddb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0012
; 760: mydbit.0 = mybyte.4
	BTFSC 0x45,4
	BSF 0x44,0
	BTFSS 0x45,4
	BCF 0x44,0
; 761: mydbit.1 = mybyte.5
	BTFSC 0x45,5
	BSF 0x44,1
	BTFSS 0x45,5
	BCF 0x44,1
; 762: Gosub adddb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0012
; 763: mydbit.0 = mybyte.6
	BTFSC 0x45,6
	BSF 0x44,0
	BTFSS 0x45,6
	BCF 0x44,0
; 764: mydbit.1 = mybyte.7
	BTFSC 0x45,7
	BSF 0x44,1
	BTFSS 0x45,7
	BCF 0x44,1
; 765: Gosub adddb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0012
; 766: 
; 767: Return
	RETURN
; 768: getdb:  'Get DiBits from store to mydbit
L0014:
; 769: Select Case tempnxt
; 770: Case 0
	MOVF 0x47,W
	SUBLW 0x00
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0168
; 771: If bptr <> 9 Then
	MOVF 0x4C,W
	SUBLW 0x09
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSC STATUS,Z
	GOTO L0169
; 772: Gosub getitback
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0018
; 773: Gosub incptr
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0016
; 774: Endif
L0169:	MOVLW 0x1F
	ANDWF STATUS,F
; 775: tempstr = myparam
	MOVF 0x36,W
	MOVWF 0x46
; 776: mydbit.0 = tempstr.0
	BTFSC 0x46,0
	BSF 0x44,0
	BTFSS 0x46,0
	BCF 0x44,0
; 777: mydbit.1 = tempstr.1
	BTFSC 0x46,1
	BSF 0x44,1
	BTFSS 0x46,1
	BCF 0x44,1
; 778: tempnxt = 2
	MOVLW 0x02
	MOVWF 0x47
; 779: Case 2
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0170
L0168:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x02
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0171
; 780: mydbit.0 = tempstr.2
	BTFSC 0x46,2
	BSF 0x44,0
	BTFSS 0x46,2
	BCF 0x44,0
; 781: mydbit.1 = tempstr.3
	BTFSC 0x46,3
	BSF 0x44,1
	BTFSS 0x46,3
	BCF 0x44,1
; 782: tempnxt = 4
	MOVLW 0x04
	MOVWF 0x47
; 783: Case 4
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0172
L0171:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x04
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0173
; 784: mydbit.0 = tempstr.4
	BTFSC 0x46,4
	BSF 0x44,0
	BTFSS 0x46,4
	BCF 0x44,0
; 785: mydbit.1 = tempstr.5
	BTFSC 0x46,5
	BSF 0x44,1
	BTFSS 0x46,5
	BCF 0x44,1
; 786: tempnxt = 6
	MOVLW 0x06
	MOVWF 0x47
; 787: Case 6
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0174
L0173:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x47,W
	SUBLW 0x06
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0175
; 788: mydbit.0 = tempstr.6
	BTFSC 0x46,6
	BSF 0x44,0
	BTFSS 0x46,6
	BCF 0x44,0
; 789: mydbit.1 = tempstr.7
	BTFSC 0x46,7
	BSF 0x44,1
	BTFSS 0x46,7
	BCF 0x44,1
; 790: tempnxt = 0
	CLRF 0x47
; 791: EndSelect
L0175:	MOVLW 0x1F
	ANDWF STATUS,F
L0174:	MOVLW 0x1F
	ANDWF STATUS,F
L0172:	MOVLW 0x1F
	ANDWF STATUS,F
L0170:	MOVLW 0x1F
	ANDWF STATUS,F
; 792: Return
	RETURN
; 793: getbyte:  'Get byte from store to mybyte
L0015:
; 794: Gosub getdb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0014
; 795: mybyte.0 = mydbit.0
	BTFSC 0x44,0
	BSF 0x45,0
	BTFSS 0x44,0
	BCF 0x45,0
; 796: mybyte.1 = mydbit.1
	BTFSC 0x44,1
	BSF 0x45,1
	BTFSS 0x44,1
	BCF 0x45,1
; 797: Gosub getdb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0014
; 798: mybyte.2 = mydbit.0
	BTFSC 0x44,0
	BSF 0x45,2
	BTFSS 0x44,0
	BCF 0x45,2
; 799: mybyte.3 = mydbit.1
	BTFSC 0x44,1
	BSF 0x45,3
	BTFSS 0x44,1
	BCF 0x45,3
; 800: Gosub getdb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0014
; 801: mybyte.4 = mydbit.0
	BTFSC 0x44,0
	BSF 0x45,4
	BTFSS 0x44,0
	BCF 0x45,4
; 802: mybyte.5 = mydbit.1
	BTFSC 0x44,1
	BSF 0x45,5
	BTFSS 0x44,1
	BCF 0x45,5
; 803: Gosub getdb
	BSF PCLATH,3
	BCF PCLATH,4
	CALL L0014
; 804: mybyte.6 = mydbit.0
	BTFSC 0x44,0
	BSF 0x45,6
	BTFSS 0x44,0
	BCF 0x45,6
; 805: mybyte.7 = mydbit.1
	BTFSC 0x44,1
	BSF 0x45,7
	BTFSS 0x44,1
	BCF 0x45,7
; 806: Return
	RETURN
; 807: incptr:  'increment the block address and pointer as necessary if full bptr = 9
L0016:
; 808: If aptr = mymax(bptr) Then
	MOVF 0x4D,W
	MOVWF R5L
	MOVF 0x4C,W
	ADDLW 0x48
	MOVWF FSR
	MOVF R5L,W
	SUBWF INDF,W
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0176
; 809: If bptr = 3 Then
	MOVF 0x4C,W
	SUBLW 0x03
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0177
; 810:  'all full set pointer to 9
; 811: bptr = 9
	MOVLW 0x09
	MOVWF 0x4C
; 812: Else
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0178
L0177:	MOVLW 0x1F
	ANDWF STATUS,F
; 813: bptr = bptr + 1 'set to stat of next block
	MOVF 0x4C,W
	ADDLW 0x01
	MOVWF 0x4C
; 814: Endif
L0178:	MOVLW 0x1F
	ANDWF STATUS,F
; 815: aptr = 0
	CLRF 0x4D
; 816: Else
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0179
L0176:	MOVLW 0x1F
	ANDWF STATUS,F
; 817: aptr = aptr + 1
	MOVF 0x4D,W
	ADDLW 0x01
	MOVWF 0x4D
; 818: Endif
L0179:	MOVLW 0x1F
	ANDWF STATUS,F
; 819: Return
	RETURN
; 820: storeit:  'Add the byte in myparam to the store at next address
L0017:
; 821: Select Case bptr
; 822: Case 0
	MOVF 0x4C,W
	SUBLW 0x00
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0180
; 823: mydata(aptr) = myparam
	MOVF 0x36,W
	MOVWF R5L
	MOVF 0x4D,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 824: Case 1
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0181
L0180:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x01
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0182
; 825: mydata1(aptr) = myparam
	MOVF 0x36,W
	MOVWF R5L
	MOVF 0x4D,W
	ADDLW 0xA0
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
; 826: Case 2
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0183
L0182:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x02
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0184
; 827: mydata2(aptr) = myparam
	MOVF 0x36,W
	MOVWF R5L
	MOVF 0x4D,W
	ADDLW 0x10
	MOVWF FSR
	MOVF R5L,W
	BSF STATUS,IRP
	MOVWF INDF
	BCF STATUS,IRP
; 828: Case 3
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0185
L0184:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x03
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0186
; 829: mydata3(aptr) = myparam
	MOVF 0x36,W
	MOVWF R5L
	MOVF 0x4D,W
	ADDLW 0x90
	MOVWF FSR
	MOVF R5L,W
	BSF STATUS,IRP
	MOVWF INDF
	BCF STATUS,IRP
; 830: EndSelect
L0186:	MOVLW 0x1F
	ANDWF STATUS,F
L0185:	MOVLW 0x1F
	ANDWF STATUS,F
L0183:	MOVLW 0x1F
	ANDWF STATUS,F
L0181:	MOVLW 0x1F
	ANDWF STATUS,F
; 831: Return
	RETURN
; 832: getitback:  'get the byte in the store at next address to myparam
L0018:
; 833: Select Case bptr
; 834: Case 0
	MOVF 0x4C,W
	SUBLW 0x00
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0187
; 835: myparam = mydata(aptr)
	MOVF 0x4D,W
	ADDLW 0x4E
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x36
; 836: Case 1
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0188
L0187:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x01
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0189
; 837: myparam = mydata1(aptr)
	MOVF 0x4D,W
	ADDLW 0xA0
	MOVWF FSR
	MOVF INDF,W
	MOVWF 0x36
; 838: Case 2
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0190
L0189:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x02
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0191
; 839: myparam = mydata2(aptr)
	MOVF 0x4D,W
	ADDLW 0x10
	MOVWF FSR
	BSF STATUS,IRP
	MOVF INDF,W
	MOVWF 0x36
	BCF STATUS,IRP
; 840: Case 3
	BSF PCLATH,3
	BCF PCLATH,4
	GOTO L0192
L0191:	MOVLW 0x1F
	ANDWF STATUS,F
	MOVF 0x4C,W
	SUBLW 0x03
	BSF PCLATH,3
	BCF PCLATH,4
	BTFSS STATUS,Z
	GOTO L0193
; 841: myparam = mydata3(aptr)
	MOVF 0x4D,W
	ADDLW 0x90
	MOVWF FSR
	BSF STATUS,IRP
	MOVF INDF,W
	MOVWF 0x36
	BCF STATUS,IRP
; 842: EndSelect
L0193:	MOVLW 0x1F
	ANDWF STATUS,F
L0192:	MOVLW 0x1F
	ANDWF STATUS,F
L0190:	MOVLW 0x1F
	ANDWF STATUS,F
L0188:	MOVLW 0x1F
	ANDWF STATUS,F
; 843: Return
	RETURN
; End of program
	BSF PCLATH,3
	BCF PCLATH,4
L0194:	GOTO L0194
; Configuration word settings
	ORG 0x2007
	DW 0x3F63
	DW 0x3FFC
; End of listing
	END
